#ifndef IDPDADETERMINIZER_H_
#define IDPDADETERMINIZER_H_

#include <string>
#include <set>
#include <map>
#include <list>

#include "automaton/State.h"
#include "DeterminizationUtils.h"
#include "automaton/PDA/PDA.h"
#include "automaton/PDA/TransitionPDA.h"

using namespace std;
using namespace automaton;

namespace determinization {

class IDPDADeterminizer {
protected:
    PDA* nondeterministicIDPDA;
    PDA* deterministicIDPDA;
    
    set<State> findToStates(const set<State>& nidpdaStates, const Symbol& input, list<Symbol>* stackPop, list<Symbol>* stackPush);
    
public:
    IDPDADeterminizer(PDA* automaton);
    PDA* determinize();
    
};

} /* namespace determinization */
#endif /* IDPDADETERMINIZER_H_ */