#ifndef VPADETERMINIZER2_H_
#define VPADETERMINIZER2_H_

#include <string>
#include <set>
#include <map>
#include <vector>

#include "automaton/PDA/PDA.h"
#include "automaton/Transition.h"
#include "alphabet/Symbol.h"
#include "DeterminizationUtils.h"
#include "VPADeterminizationUtils.h"
#include "VPADeterminizationStructs.h"

using namespace std;
using namespace automaton;
using namespace alphabet;

namespace determinization {

class VPADeterminizer3 {
protected:
    static string buildStateName(const SComponent& s);
    static string buildStackSymbolName(const SComponent& s, const Symbol& input);
    static const State& getOrCreateState(const SComponent& s, map<string, StateData>& states, PDA& deterministicVPA);
    static vector<SComponent> buildStackAlphabet(PDA& nondeterministicVPA, PDA& deterministicVPA, set<Symbol>& callSymbols);

public:
    static PDA determinize(PDA& automaton);
};

} /* namespace determinization */
#endif /* VPADETERMINIZER2_H_ */