#ifndef DETERKMINIZATIONUTILS_H_
#define DETERKMINIZATIONUTILS_H_

#include <iostream>
#include <string>
#include <set>
#include <map>
#include <algorithm>

#include "automaton/State.h"
#include "automaton/Automaton.h"
#include "automaton/PDA/PDA.h"

using namespace std;
using namespace automaton;

namespace determinization {

class DeterminizationUtils {
public:
    struct StateData {
        const State state;
        const set<State> originalStates;
        bool isMarked;
        
        StateData(const State& state, const set<State>& originalStates)
                : state(state),
                  originalStates(originalStates) {
            this->isMarked = false;
        }
    };
    
    static string buildStateName(const set<State>& states);
    static const State& getOrCreateState(const set<State>& originalStates, map<string, StateData>& states, Automaton& automaton);
    static void copyInputAlphabet(const Automaton& fromAutomaton, Automaton& toAutomaton);
    static void copyStackAlphabet(const PDA& fromPDA, PDA& toPDA);
    static bool containSomeFinalStateOfAutomaton(const set<State>& states, const Automaton& automaton);
};

} /* namespace determinization */
#endif /* DETERKMINIZATIONUTILS_H_ */