/*
 * String.cpp
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnicek
 */

#include "String.h"
#include "StringPrinter.h"
#include "../AlibException.h"

namespace notions {
namespace string {

String::String() {

}

void String::addAlphabetSymbol(const alphabet::Symbol& symbol) {
	std::pair<std::set<alphabet::Symbol>::iterator, bool> ret = this->alphabet.insert(symbol);
	if (!ret.second)
		throw alib::AlibException("Input symbol \"" + symbol.getSymbol() + "\" already exists.");
}

void String::removeAlphabetSymbol(const alphabet::Symbol& symbol) {
	auto it = this->alphabet.find (symbol);
	if(it != this->alphabet.end())
		throw alib::AlibException("Input symbol \"" + symbol.getSymbol() + "\" used in string.");
	this->alphabet.erase(symbol);
}
	
const std::set<alphabet::Symbol>& String::getAlphabet() const {
	return this->alphabet;
}

std::list<alphabet::Symbol>& String::getContent() {
	return this->symbols;
}

const std::list<alphabet::Symbol>& String::getContent() const {
	return this->symbols;
}

bool String::isEmpty() const {
	return this->symbols.size() == 0;
}

void String::toXML(std::ostream& out) {
	StringPrinter::toXML(*this, out);
}

std::ostream& operator <<(std::ostream& out, String& string) {
	string.toXML(out);
	return out;
}

} /* namespace string */
} /* namespace notions */
