/*
 * RegExpIntegral.h
 *
 *  Created on: 24. 2. 2014
 *      Author: tomas
 */

#ifndef REGEXPINTEGRAL_H_
#define REGEXPINTEGRAL_H_

#include <AlibException.h>
#include <regexp/RegExp.h>
#include <regexp/RegExpElement.h>
#include <regexp/Alternation.h>
#include <regexp/Concatenation.h>
#include <regexp/Iteration.h>
#include <regexp/RegExpSymbol.h>
#include <regexp/RegExpEmpty.h>
#include <regexp/RegExpEpsilon.h>

class RegExpIntegral
{
public:
    RegExpIntegral( const regexp::RegExp & re );
    regexp::RegExp integral( const std::list<regexp::RegExpElement*> & dString ) const;

private:
    regexp::RegExpElement * integral( const regexp::RegExpElement * node, const regexp::RegExpSymbol & dSymbol ) const;
    regexp::RegExpElement * integral( const regexp::Alternation * node, const regexp::RegExpSymbol & dSymbol ) const;
    regexp::RegExpElement * integral( const regexp::Concatenation * node, const regexp::RegExpSymbol & dSymbol ) const;
    regexp::RegExpElement * integral( const regexp::Iteration * node, const regexp::RegExpSymbol & dSymbol ) const;
    regexp::RegExpElement * integral( const regexp::RegExpSymbol * node, const regexp::RegExpSymbol & dSymbol ) const;
    regexp::RegExpElement * integral( const regexp::RegExpEpsilon * node, const regexp::RegExpSymbol & dSymbol ) const;
    regexp::RegExpElement * integral( const regexp::RegExpEmpty * node, const regexp::RegExpSymbol & dSymbol ) const;

    const regexp::RegExp & m_re;
};

#endif /* REGEXPINTEGRAL_H_ */
